#!/usr/bin/env bash

# phase2で作成したヨミ辞書(yomi0.txt)を以下の形式にする
#       単語\tヨミ ヨミは1つだけ
#       問題として、不適切・不要な行を削除する

yomi0="data/inprogress/yomi/yomi0.txt"  # phase2から継承
yomi1="data/inprogress/yomi/yomi1.txt"  # 非第1正規形
yomi2="data/inprogress/yomi/yomi2.txt"  # 第1正規形
yomi3="data/inprogress/yomi/yomi3.txt"  # 第1正規形で複数のヨミがあるもの
yomi4="data/inprogress/yomi/yomi4.txt"  # 正規形
yomi5="data/inprogress/yomi/yomi5.txt"  # [手編集] yomi1 非第1正規形
yomi6="data/inprogress/yomi/yomi6.txt"  # [手編集] yomi3 複数のヨミがあるものからヨミを1つ選ぶ
yomi7="data/inprogress/yomi/yomi7.txt"  # [手編集] yomi4 ラリルレローを含むもの
yomi8="data/inprogress/yomi/yomi8.txt"  # [手編集] yomi4 ラリルレローを含まないもの
yomi="data/inprogress/yomi.txt"

nonreguler1() {
    < $yomi0 awk -F $'\t' '
        $1 ~ /.*[ ].*[ ]/       # 単語が3単語以上のものを抽出
        $1 ~ /^[A-Z ]+$/        # 大文字だけで構成された単語を抽出
    '
}

nonreguler2() {
    < $yomi2 awk -F $'\t' '
        NF>2                    # ヨミが複数ある行を抽出
    '
}

phase3() {
    nonreguler1 > $yomi1 # ヨミ辞書から、正規形でないデータを抽出する $yomi1
    comm -23 $yomi0 $yomi1 > $yomi2 # ヨミ辞書から、第1正規形データのみを抽出する $yomi0 -$yomi1 = $yomi2
    nonreguler2 > $yomi3 # 第1正規形データからヨミが複数あるデータを抽出する $yomi3
    comm -23 $yomi2 $yomi3 > $yomi4 # 第1正規形データから正規形データのみを抽出する $yomi2 -$yomi3 = $yomi4
    cp $yomi1 $yomi5 # 手作業で、非正規形のデータ$yomi1を編集する $yomi5
    cp $yomi3 $yomi6 # 手作業で、非正規形のデータ$yomi3を編集する $yomi6
    #vim $yomi5 $yomi6
    read -p "vim $yomi5 $yomi6 が完了したら" 
    # 正規形でヨミに"ラリルレロー"を含むものと含まないものに分類
    egrep '[ラリルレロー]' $yomi4 > $yomi7
    egrep -v '[ラリルレロー]' $yomi4 > $yomi8
    # 手作業で編集
    #vim $yomi7 $yomi8
    read -p "vim $yomi7 $yomi8 が完了したら" 
    cat $yomi5 $yomi6 $yomi7 $yomi8 | sort -k 1,1 > $yomi # yomi5, yomi6, yomi7, yomi8を結合する
}

dry() {
    read -p "ヨミ辞書から、正規形でないデータを抽出する $yomi1"
    nonreguler1
    read -p "ヨミ辞書から、第1正規形データのみを抽出する $yomi0 -$yomi1 = $yomi2"
    comm -23 $yomi0 $yomi1
    read -p "第1正規形データからヨミが複数あるデータを抽出する $yomi3"
    nonreguler2
    read -p "第1正規形データから正規形データのみを抽出する $yomi2 -$yomi3 = $yomi4"
    comm -23 $yomi2 $yomi3
    read -p "$yomi5 $yomi6 を手作業編集"
    read -p "$yomi4 正規形でヨミに「ラリルレロー」を含むもの"
    egrep '[ラリルレロー]' $yomi4
    read -p "$yomi4 正規形でヨミに「ラリルレロー」を含まないもの"
    egrep -v '[ラリルレロー]' $yomi4
    read -p "$yomi7 $yomi8 を手作業編集したら、$yomi5, $yomi6, $yomi7, $yomi8 を結合する" 
    cat $yomi5 $yomi6 $yomi7 $yomi8 | sort -k 1,1
}

dry
#phase3
